	device zxspectrum128
        ORG #6000
begin
; jr $
;$C6,$ce,$D6,$de,$e6,$ee,$F6,$FE
; set 0,(hl) 11 000 110
; set 1,(hl) 11 001 110
; set 2,(hl) 11 010 110
; set 3,(hl) 11 011 110
; set 4,(hl) 11 100 110
; set 5,(hl) 11 101 110
; set 6,(hl) 11 110 110
; set 7,(hl) 11 111 110
	ld sp,$5FE0
	ld a,$10
	ld bc,$7FFD
	out (c),a
; zero $8000-$FFFF
	ld hl,$8000
	ld de,$8001
	ld bc,$1000-1
	ld (hl),l
	ldir
; 
	ld hl,titlep
	ld de,$4000
	call dzx7_standard
	
;build tables
sinpl equ $7000
	ld hl,sintab,de,sinpl,bc,256:ldir
	
	ld l,0
	ld de,$4000;
blp:
	ld h,1+sinpl/256
	ld a,l

	cpl
	and 7
	add a,a
	add a,a
	add a,a
	add a,$C6;set

	ld (hl),a
	inc h

	ld a,l
	srl a
	srl a
	srl a
	ld (hl),a
	inc h
	ld (hl),e
	inc h
	ld (hl),d
	call nbde
	inc l
	jr nz,blp

;; 
;	ld hl,sinpl
;s_lp:
;	push hl
;	ld e,l
;	ld d,(hl)
;	inc h
;	ld a,(hl)
;	ld (putt+1),a
;	inc h
;	ld a,(hl)
;	inc h
;	ld l,d
;	add a,(hl)
;	inc h
;	ld e,a
;	ld d,(hl)
;	ex de,hl
;putt:
;	set 0,(hl)
;	
;	pop hl
;	inc l
;	jp nz,s_lp
;	jr $
;;  
;	ld e,0
;tes:
;	ld h,1+sinpl/256
;	ld d,e;D.E=y.x
;	ld a,192
;	sub e
;	ld l,a
;	
;	push de
;	ld a,(hl)
;	ld (putt+1),a
;	inc h
;	ld a,(hl)
;	inc h
;	ld l,d
;	add a,(hl)
;	inc h
;	ld e,a
;	ld d,(hl)
;	ex de,hl
;putt:
;	set 0,(hl)
;	pop de
;	inc e
;	ld a,e
;	cp 128+63
;	jp nz,tes
; jr $


; generate pop hl:ld (hl),a
	ld hl,stackout
	ld b,0
gen1:
	ld (hl),$E1:inc hl
	ld (hl),$77:inc hl
	djnz gen1
	ld de,sp1
	call put_c3

	ld (jumpdot+1),hl;  

; generate pop hl:set 0,(hl)
	ld b,0
gen2:
	ld (hl),$E1:inc hl
	ld (hl),$CB:inc hl
	ld (hl),$C6:inc hl
	djnz gen2
	ld (codep+1),hl ;    
	ld de,sp2
	call put_c3


;setup im2
	di
	ld a,$5F
	ld i,a
	im 2
	ld hl,intvec
	ld ($5FFF),hl
	call calcdots
;	jr $
gg:
	ei
	halt
	ld a,1:out ($FE),a
	call zerodots
	call drawdots
	ld a,0:out ($FE),a
	call calcdots
	ld a,6:out ($FE),a
;;	call psgplay
;;	ld a,7:out ($FE),a
	call checkkeys
;	  
;256 *2=512   
;$8000-$8200
;$8400-$8600

	jp gg
checkkeys:
	ld bc,$FBFE
	in a,(c)
	and 1
	jr nz,test_A
	ld a,(delta_e+1)
	inc a
	ld (delta_e+1),a
	ret
test_A:
	ld bc,$FDFE
	in a,(c)
	and 1
	jr nz,test_W
	ld a,(delta_e+1)
	dec a
	ld (delta_e+1),a

test_W:
	ld bc,$FBFE
	in a,(c)
	and 2
	jr nz,test_S
	ld a,(delta_d+1)
	inc a
	ld (delta_d+1),a
	ret
test_S:
	ld bc,$FDFE
	in a,(c)
	and 2
	jr nz,test_E
	ld a,(delta_d+1)
	dec a
	ld (delta_d+1),a
	ret
test_E:
	ld bc,$FBFE
	in a,(c)
	and 4
	jr nz,test_D
	ld a,(delta_c+1)
	inc a
	ld (delta_c+1),a
	ret
test_D:
	ld bc,$FDFE
	in a,(c)
	and 4
	jr nz,test_R
	ld a,(delta_c+1)
	dec a
	ld (delta_c+1),a
	ret
test_R:
	ld bc,$FBFE
	in a,(c)
	and 8
	jr nz,test_F
	ld a,(delta_b+1)
	inc a
	ld (delta_b+1),a
	ret
test_F:
	ld bc,$FDFE
	in a,(c)
	and 8
	jr nz,test_0
	ld a,(delta_b+1)
	dec a
	ld (delta_b+1),a
	ret
test_0:
	ld bc,$EFFE
	in a,(c)
	and 1
	ret nz
	ld a,1,(delta_e+1),a
	ld a,0-2,(delta_d+1),a
	ld a,2,(delta_c+1),a
	ld a,0-1,(delta_b+1),a
	ret
 ; jp NNNNN,DE=NNNNN
put_c3:
	ld (hl),$C3:inc hl
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	ret
nbde
    inc d
    ld a,d
    and 7
    ret nz
    ld a,e
    add a,#20
    ld e,a
    ret c
    ld a,d
    sub 8
    ld d,a
    ret

; 
calcdots:
	ld (sp3+1),sp
spp1:	ld sp,$8600
	exx
codep:ld hl,0
	dec hl
	exx
cva1:ld de,$4060
;	inc e

	ld a,e
delta_e:	add a,1
	ld e,a

;	dec d
;	dec d
	ld a,d
delta_d:	add a,0-2
	ld d,a

	ld (cva1+1),de

cva2:ld bc,0
;	inc c
;	inc c
	ld a,c
delta_c:	add a,2
	ld c,a

;	dec b
	ld a,b
delta_b:	add a,0-1
	ld b,a

	ld (cva2+1),bc

	ld ixl,0
cd_lp:
	ld h,sinpl/256
	ld l,c
	ld a,(hl)
	ld l,b
	add a,(hl)
	inc c
	inc b
	inc b
	inc b

;	ld a,ixl
	ld (xv+1),a;A=X

	ld l,e
	ld a,(hl)
	ld l,d
	add a,(hl)
	inc e
	inc d
	inc d

;	ld a,ixl
;	ld l,a
;	ld a,(hl)
	exa;store Y

xv:ld l,0

	inc h;  $CB
	ld a,(hl)
	exx
	ld (hl),a
	dec hl
	dec hl
	dec hl
	
;	ld (pt+1),a
	exx
	inc h;X/8

	ld a,(hl)
	exa
	ld l,a
	exa
	inc h
	or (hl);add a,(hl)
	inc h
	ld h,(hl)
	ld l,a
	push hl
;pt: set 0,(hl)
	dec ixl
	jp nz,cd_lp
sp3:ld sp,0
	ld a,(spp1+2);->$86 <-> $82,calcdots
	xor 4
	ld (spp1+2),a
	ret

;  
zerodots:
	ld (sp1+1),sp
spp2:	ld sp,$8000
	xor a
	jp stackout
sp1:ld sp,0
	ld a,(spp2+2);->$80 <-> $84,zerodots
	xor 4
	ld (spp2+2),a
	ret
;  
drawdots:
	ld (sp2+1),sp
spp3: ld sp,$8400
jumpdot: jp 0
sp2:ld sp,0
	ld a,(spp3+2);->$84 <-> $80,drawdots
	xor 4
	ld (spp3+2),a
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
intvec:
	push hl,de,bc,af
	call psgplay
	pop af,bc,de,hl
	ei
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
song=65534-25029
;---------------play PSG dump-----------
psgplay:ld a,1:or a:jr z,psga
 dec a:ld (psgplay+1),a:ret
psga: ld hl,song;+16

dumpreg:
 	ld e,(hl):inc hl
 	ld a,e
 	cp #FF:jr z,stoplay
 	cp #FE:jr nz,nogetwait
    ld e,(hl):inc hl;(hl)*4
 ld a,e
 add a,a
 add a,a
 ld (psgplay+1),a:jr stoplay

nogetwait:
    cp #FD:jr z,stoplay2
	ld bc,0xfffd
	out (c),e
	ld e,(hl):inc hl
	ld b,0xbf
	out (c),e
    jr dumpreg
stoplay2:
  ld hl,song;+16
stoplay:
 ld (psga+1),hl
 ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
stackout:

sintab:incbin "sindots.data"
zx7:include "zx7.a80"
titlep:incbin "sdtitle.scr.zx7"
end


	display /d,end-begin
	savebin "sinedots.code",begin,end-begin
;	savesna "!void.sna",begin


